CREATE TABLE route (
    envelope_id uuid NOT NULL,
    id bigint NOT NULL,
    process_id uuid NOT NULL,
    source text NOT NULL
);

CREATE SEQUENCE route_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;

ALTER SEQUENCE route_id_seq OWNED BY route.id;

CREATE TABLE route_target (
    route_id bigint NOT NULL,
    actor_id uuid NOT NULL,
    node_id character varying(255) NOT NULL,
    input character varying(255) NOT NULL,
    id bigint NOT NULL
);

CREATE SEQUENCE route_target_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;

ALTER SEQUENCE route_target_id_seq OWNED BY route_target.id;

ALTER TABLE ONLY route ALTER COLUMN id SET DEFAULT nextval('route_id_seq'::regclass);
ALTER TABLE ONLY route_target ALTER COLUMN id SET DEFAULT nextval('route_target_id_seq'::regclass);

ALTER TABLE ONLY route
    ADD CONSTRAINT route_pkey PRIMARY KEY (id);
ALTER TABLE ONLY route_target
    ADD CONSTRAINT route_target_pkey PRIMARY KEY (id);

ALTER TABLE ONLY route
    ADD CONSTRAINT u_route_process_id_source_envelope_id UNIQUE (process_id, source, envelope_id);
ALTER TABLE ONLY route_target
    ADD CONSTRAINT u_route_target_route_id_actor_id_node_id_input UNIQUE (route_id, actor_id, node_id, input);

ALTER TABLE ONLY route
    ADD CONSTRAINT route_process_id_fkey FOREIGN KEY (process_id) REFERENCES process(id);

ALTER TABLE ONLY route_target
    ADD CONSTRAINT route_target_actor_id_fkey FOREIGN KEY (actor_id) REFERENCES actor(id);

ALTER TABLE ONLY route_target
    ADD CONSTRAINT route_target_route_id_fkey FOREIGN KEY (route_id) REFERENCES route(id);


