// Copyright 2016 Orus.io. All rights reserved.

package model

import (
	"github.com/m4rw3r/uuid"

	"bitbucket.org/orus-io/go-xbus/api"
)

//go:generate yago --fmt

// Pipeline stores pipeline data
//yago:autoattrs
type Pipeline struct {
	Base
	Name    string                  `yago:"unique_index=name_version"`
	Version string                  `yago:"unique_index=name_version"`
	Status  api.PipelineInfo_Status `yago:"textmarshaled"`
	Edges   string                  `yago:"type=qb.Text()"`
}

// GraphNode is a graph vertex
//yago:autoattrs
type GraphNode struct {
	ID                    int64     `yago:"auto_increment,primary_key"`
	PipelineID            uuid.UUID `yago:"fk=Pipeline,unique_index=graph_node"`
	NodeID                string    `yago:"unique_index=graph_node"`
	Type                  string
	ActorIDs              string
	Actors                string
	Roles                 string
	RoleBroadcast         bool
	SourceMatchEventTypes string
	Inputs                string `yago:"type=qb.Text()"`
	Outputs               string `yago:"type=qb.Text()"`
}
