// Copyright 2016 Orus.io. All rights reserved.

package mocks

import (
	"testing"

	"bitbucket.org/orus-io/xbus/storage"
	"bitbucket.org/orus-io/xbus/testutils"
	storagetest "bitbucket.org/orus-io/xbus/testutils/storage"
)

func factory(t testing.TB) (storage.EnvelopeStorage, func()) {
	return NewEnvelopeStorage(testutils.GetTestLogger(t)), func() {}
}

func TestEnvelopeStorage(t *testing.T) {
	storagetest.EnvelopeStorageTests(t, factory,
		true, // supportUnordered
	)
}

func BenchmarkEnvelopeStorage(b *testing.B) {
	storagetest.EnvelopeStorageBench(b, factory)
}
